function H=ParamMetricCalib(k,t,gamma,F,M,eA,eB)

%F=F/MatrixNorm(F);
Fp=(F+F')/2;
Fm=(F-F')/2;
mu=[Fm(3,2) Fm(1,3) Fm(2,1)]';

%% M and eA,eB could be found here...

h3=inv(k*eye(3)-M)*eB;
h3=h3/norm(h3);
h3

h1=cross(Fp*mu,Fp*h3);
h1=h1/norm(h1);

h2=(1-t)*h3+t*mu;
h2=h2/norm(h2);

L12=cross(h1,h2);
L12=L12/norm(L12);

p1=[ 6.24532 1.213213 1 ]';
p2=[ -9.2131324 2.674213 1]';
a1=cross(p1,eA);
a2=cross(p2,eA);
b1=F*p1;
b2=F*p2;
%% thus Tab'*bi == ai
a1=a1/norm(a1);
b1=b1/norm(b1);
a2=a2/norm(a2);
b2=b2/norm(b2);

M=TabLineMatch(L12,L12);
M=[M; TabLineMatch(a1,b1)];
M=[M; TabLineMatch(a2,b2)];
M=[M; TabDirectionMatch(h3,h3)];

M=M'*M;
[U,S,V]=svd(M);
Tab=[ V(1:3,9)'; V(4:6,9)'; V(7:9,9)' ];

[D,S]=eig(Tab);
R=(S+conj(S))/2;
if R(1,1)==S(1,1),
  th=acos(R(2,2));
else
  th=acos(R(1,1));
end
th

U=[sin(th)*h2, cos(th)*h3, -mu];
[UU,SS,VV]=svd(U);
Q=VV(:,3);
Q=Q/Q(3);
invk2=Q(1);
invk3gamma=Q(2);
invk3=invk3gamma/gamma;

u=Fp*h3;
v=cross(h1,h3)*(1-cos(th));
invk1=u(1)/v(1);

hh1=invk1*h1;
hh2=invk2*h2;
hh3=invk3*h3;

H=[hh1 hh2 hh3];
