function [H,th]=ParamMetricCalib3(k,gamma,F,M,eA,eB)

%F=F/MatrixNorm(F);
Fp=(F+F')/2;
Fm=(F-F')/2;
mu=[Fm(3,2) Fm(1,3) Fm(2,1)]';

%% M and eA,eB could be found here...

h3=inv(k*eye(3)-M)*eB;
h3=h3/norm(h3);

h1=cross(Fp*mu,Fp*h3);
h1=h1/norm(h1);

Q=[ Fp*h1, -Fm*h3 ];
[U,S,V]=svd(Q'*Q);
invk1=V(1,2);
invk3gamma=V(2,2);
invk1*Fp*h1-invk3gamma*Fm*h3

q1=[ -Fp*h3; -mu ];
q2=[ cross(h1,h3)*invk1; 0; 0; 0 ];
q3=[ -invk1*cross(h1,h3); invk3gamma*h3 ];
q4=[ 0; 0; 0; h3 ];
q5=[ 0; 0; 0; mu-h3 ];
Q=[ q1 q2 q3 q4 q5 ];
[U,S,V]=svd(Q'*Q);
S
Q*V(:,5)
t=V(5,5)/V(4,5);
th=atan(V(4,5)/V(3,5));
phi=V(1,5)/V(2,5);

h2=(1-t)*h3+t*mu
h2=(phi*mu-invk3gamma*cos(th)*h3)/sin(th)
V(1,5)*Fp*h3-V(2,5)*(1-cos(th))*invk1*cross(h1,h3)

invk3=invk3gamma/gamma;

hh1=invk1*h1;
hh2=h2;
hh3=invk3*h3;

H=[hh1 hh2 hh3];

