function H=ParamMetricCalib4(k,gamma,ang,F,M,eA,eB)

Fp=(F+F')/2;
Fm=(F-F')/2;
mu=[Fm(3,2) Fm(1,3) Fm(2,1)]';

%% M and eA,eB could be found here...

h3=inv(k*eye(3)-M)*eB;
h3=h3/norm(h3);

h1=cross(Fp*mu,Fp*h3);
h1=h1/norm(h1);

Q=[ Fp*h1, -Fm*h3 ];
[U,S,V]=svd(Q'*Q);
invk1=V(1,2);
invk3gamma=V(2,2);

u=(1-cos(ang))*invk1*cross(h1,h3);
v=Fp*h3;
phi=u(1)/v(1);

h2=(phi*mu-invk3gamma*cos(ang)*h3)/sin(ang);

invk3=invk3gamma/gamma;

hh1=invk1*h1;
hh2=h2;
hh3=invk3*h3;

H=[hh1 hh2 hh3];


