%% Test of equations (5) and (6) of "View Morphing" paper in SIGGRAPH

f0=sym('f0','real');
f1=sym('f1','real');
Cx=sym('Cx','real');
Cy=sym('Cy','real');
s=sym('s','real');

PI0=[f0 0 0 0; 0 f0 0 0; 0 0 1 0];

PI1=[f1 0 0 -f1*Cx; 0 f1 0 -f1*Cy; 0 0 1 0];

PIs=(1-s)*PI0+s*PI1

%% The following should be 0, since optical center of camera (in
%% universal coordinates) should be mapped to 0 in camera's coords

simplify(PI1*[Cx Cy 0 1]')

simplify(PIs*[s*Cx s*Cy 0 1]')

%% The last vector is 0 only when s==0 or s==1 (representing the
%% original cameras).
